﻿################################################################################
########################## Pipeline 2 ##########################################
################################################################################
################################################################################
################################################################################

<#
Now that we've been introduced to the pipeline, let's take a closer look at
pipelining with filters and loops.  We'll start with filters because they setup
the looping concepts we need to understand some other things.
#>

##Let's start with something we've already seen.
dir

##We've got a list of files here.  Let's filter it to see the list we're interested in.

##Now let's get the members so we can see what properties are available to us.
dir | gm

##When you pick a property you can then use it in a loop operator.
dir | Where-Object{$_.Name -eq "Outline.docx"}

##We'll take a moment to understand what's happening here.

dir #-- get the list of objects.
| #-- passes that list as input to the next cmdlet.
Where-Object{} #-- This is actually a looping operator even though it doesn't look 
# like it. This loop filters the resultset.
$_ #--This is the current object currently in the pipeline.
.Name #-- the property we want to filter by.
-eq #-- comparison operator.  Same as = in other langs.

##Let's look specifically at how to call properties.
##To access properties you use the object.property syntax.

##So we can set objects to vars and that can make it really easy to work with the data.
$a = dir

$a
$a.Name

##Here's an example with more pipes.
dir | gm | ?{$_.MemberType -eq 'Property'}

################# Exercises #################3

<#
1. Open PS and pull up a listing in the current directory you're in.
2. Create a variable with the contents of a directory listing.
3. List all the properties for the variable you just created.
4. Limit the members in the variable above to just properties.
5. Display all the members of the get-service cmdlet.
#>














