﻿################################################################################
########################## Cmdlets 2 ###########################################
################################################################################
################################################################################
################################################################################

<#
We also need to know how to use methods.  Methods are verbs, or actions that can be
performed against an object.  You won't always understand what all the methods do,
but it's fairly easy to pick out the ones you can use.  And most of the time it's
easy.
#>


################# Exercises #################

<#
1. Stop the Volume Shadow Copy service and start it again.
2. Set the Volume Shadow Copy service to start manually instead of automatically.
3. Open notepad in PS by simply typing notepad at the cmdline. Then close
	it using PS.
4. Create a file with a list of all services that start with T.
5. Stop and start the Volume Shadow Copy service again, only this time, use the 
start-service and stop-service cmdlets.
6. List every file in a folder with its size. Make sure it's formatted well.
	HINT: Maybe put it into a table?
#>

#1. Stop the Volume Shadow Copy service and start it again.
get-service | ?{ $_.Displayname -match "Task" } | Stop-Service;
#or
get-service | ?{ $_.Displayname -eq "Volume Shadow Copy" } | %{$_.Stop()};
#or
get-service -include "Schedule" # Notice you use the Name instead of the DisplayName for the -Include.
#or

#2. Set the Volume Shadow Copy service to start manually instead of automatically.
gwmi win32_service | ?{ $_.displayName -eq "Volume Shadow Copy" } | %{ $_.StartMode = "Manual" }
gwmi win32_service | ?{ $_.displayName -eq "Volume Shadow Copy" } | ft Name, DisplayName, StartMode;
gwmi win32_service | gm

#or
set-service -name VSS -StartupType "Auto"

#3. Open notepad in PS by simply typing notepad at the cmdline. Then close it using PS.
notepad
Get-Process | ?{$_.ProcessName -eq "notepad"} | %{$_.Kill()}

#4. Create a file with a list of all services that start with T.
get-service | ?{ $_.Displayname -like "T*" } | Out-File .\TServices.txt

#5. Stop and start the Volume Shadow Copy service again, only this time, use the 
#start-service and stop-service cmdlets.
get-service | ?{ $_.Displayname -eq "Volume Shadow Copy" } | Start-Service;
get-service | ?{ $_.Displayname -eq "Volume Shadow Copy" } | ft Name, DisplayName, Status;

get-service | ?{ $_.Displayname -eq "Volume Shadow Copy" } | Stop-Service;
get-service | ?{ $_.Displayname -eq "Volume Shadow Copy" } | ft Name, DisplayName, Status;

#6. List every file in a folder with its size. Make sure it's formatted well.
#HINT: Maybe put it into a table?
dir | ?{ $_.PSIsContainer -eq 0 } | ft Name, Length -auto;





