﻿
param (
	[Parameter(Mandatory = $True, HelpMessage = "Enter the FilePath without the ending '\'")]
	[string]$FilePath,
	
	[Parameter(Mandatory = $True, HelpMessage = "Specify a filename and extension i.e.(MyFile.txt)")]
	[string]$FileName)

##You have to type '!?' when you're prompted to enter a missing param if you want to see the HelpMessage text.  
##It's not displayed by default.

################################################################################
########################## Scripting 7 #########################################
################################################################################
################################################################################
################################################################################

<#
Here we're making it much easier to get help for our script w/o having to open it.  Because the problem with pass-in params is that you
still have to open the script to see what params are available.  This way you can add some very helpful documentation to your scripts
with usage advice, examples, etc.  This is a great way to provide a real value add.
#>

#$FilePath = "c:\ScriptingClass"; #Don't end in \ so we can use it in the calls below.
#$FileName = "MinionWare.txt";

If (Test-Path $FilePath\$FileName)
	{
	del $FilePath\$FileName;
	}
ELSE
	{
		"The file was not found.";
	}

##We could have put the \ in the $FilePath var itself but I prefer to see the slashes in the call.  It makes more sense to me.
##Here's what that would've looked like:

<#
$FilePath = "c:\ScriptingClass\"; 
$FileName = "MinionWare.txt";

If (Test-Path $FilePath$FileName)
{
	del $FilePath$FileName;
}
ELSE
{
	"The file was not found.";
}
#>











